#include "ggi_widget.h"
#include "ggi_widget_highlevel.h"


ggi_widget_t ggiWidgetMakeTextbutton(char *text) {


	ggi_widget_t txt,button;
	
	txt   =ggiWidgetCreateWidget(GWT_LABEL,text);
	if (!txt) return NULL;

	button=ggiWidgetCreateWidget(GWT_BUTTON,txt);
	if (!button) {
		txt->destroy(txt);
	}

	return button;
}

ggi_widget_t ggiWidgetMakeBitmapbutton(ggi_widget_bitmap_t bitmap) {
	ggi_widget_t bmap,button;
	
	bmap=ggiWidgetCreateWidget(GWT_BITMAP,bitmap);
	if (!bmap) return NULL;

	button=ggiWidgetCreateWidget(GWT_BUTTON,bmap);
	if (!button) {
		bmap->destroy(bmap);
	}

	return button;
}

#define MsgBoxBtn_Yes    (0x0001)
#define	MsgBoxBtn_Ok     (0x0002)
#define MsgBoxBtn_Retry  (0x0004)

#define MsgBoxBtn_No     (0x0010)
#define MsgBoxBtn_Ignore (0x0040)

#define MsgBoxBtn_Abort  (0x0100)

static char *MsgBoxBtnNames[32]= {
	"Yes",
	"O.K.",
	"Retry",
	"invalid",
	"No",
	"invalid",
	"Ignore",
	"invalid",
	"Abort",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid",
	"invalid"
};

static void ggiWidgetMessageBoxCallback(ggiWidgetCallbackType cbt,ggi_widget_t self) {

	int x;
	
	if (cbt!=GWT_CB_ACTIVATE) return;
	
	for(x=0;x<32;x++) {
		if (self->callbackpriv==MsgBoxBtnNames[x]) {
			goto gotone;
		}
	}
	return;

	gotone:
	while(self&&self->statevar==NULL) self=self->parent;
	if (self&&self->statevar) *((int *)self->statevar)=(1<<x);
}

ggi_widget_t ggiWidgetMakeMessagebox(char *text,int buttons,ggi_widget_t icon,int *statevar) {

	ggi_widget_t upper_line,txt,lower_line,but,msgbox;
	int x;

	upper_line=ggiWidgetCreateWidget(GWT_CONTAINER_LINE,0,0,NULL);
	if (!upper_line) return NULL;
	upper_line->gravity=GWT_GRAV_STRETCH_X;

	if (icon) {
		if (upper_line->linkchild(upper_line,LAST_CHILD,icon)) {
			goto kill_upper;
		}
	}

	txt=ggiWidgetCreateWidget(GWT_LABEL,text);
	if (!txt)
		goto kill_upper;

	if (upper_line->linkchild(upper_line,LAST_CHILD,txt)) {
		goto kill_upper;
	}

	lower_line=ggiWidgetCreateWidget(GWT_CONTAINER_LINE,0,0,NULL);
	if (!lower_line) 
		goto kill_upper;
	lower_line->gravity=GWT_GRAV_STRETCH_X;

	for(x=0;x<32;x++) {
		if (buttons&(1<<x)) {
			but=ggiWidgetMakeTextbutton(MsgBoxBtnNames[x]);
			if (!but)
				goto kill_lower;
			if (lower_line->linkchild(lower_line,LAST_CHILD,but)) {
				but->destroy(but);
				goto kill_lower;
			}
			but->callback=ggiWidgetMessageBoxCallback;
			but->callbackpriv=MsgBoxBtnNames[x];
		}
	}

	msgbox=ggiWidgetCreateWidget(GWT_CONTAINER_STACK,1,2,upper_line,lower_line,NULL);
	if (statevar) {
		*statevar=0;
		msgbox->statevar=statevar;
	}
	if (!msgbox)
		goto kill_lower;

	msgbox->gravity=GWT_GRAV_STRETCH;

	return msgbox;

	kill_lower:
	lower_line->destroy(lower_line);
	kill_upper:
	upper_line->destroy(upper_line);
	return NULL;
}
