#include <ggi/ggi.h>
#include "ggi_widget.h"
#include "ggi_widget_highlevel.h"
#include "ggi_widget_bitmap.h"

int quit=0;

void callback(ggiWidgetCallbackType cbt,ggi_widget_t widget) {

	fprintf(stderr,"Callback %d from %p with %p.\n",cbt,widget,widget->callbackpriv);
	if (cbt==GWT_CB_ACTIVATE)
		quit=1;
}

#define WAIT 100000

int main(int argc,char *argv[]) {

	ggi_visual_t vis;
	ggi_widget_t lab1,lab,cblab,but1,but2,cline,cstack,bmap,txt,cline2,odo,dial;
	ggi_widget_bitmap_t bitmap;
	char testtext[80]="Testtext - oneliner\0huhu";
	double odoread1,odoread2;
	int x;
	
	ggiInit();
	vis=ggiOpen(NULL);
	
	if (!vis) {
		fprintf(stderr,"Huh ?\n");
		ggiExit();
		return 1;
	}
	
	ggiSetFlags(vis,GGIFLAG_ASYNC);
	ggiSetSimpleMode(vis,256,512,1,GT_AUTO);

	bitmap=ggiWidgetBitmapLoadPBM("question.pbm");
	ggiSetGCForeground(vis,ggiMapColor(vis,&ggi_widget_default_colorset.background));
	if (bitmap) ggiWidgetBitmapPlot(bitmap,vis,0,0);
	else fprintf(stderr,"HUH?\n");
	ggiFlush(vis);
	usleep(WAIT);

	lab  =ggiWidgetCreateWidget(GWT_LABEL,"WARNING:\nYou are now using\nLibGGI based\nWidgets\n");
	lab1 =ggiWidgetCreateWidget(GWT_LABEL,"O.K.");
	but1 =ggiWidgetCreateWidget(GWT_BUTTON,lab1);
	cblab=ggiWidgetCreateWidget(GWT_LABEL,"Checkbox");
	but2 =ggiWidgetCreateWidget(GWT_CHECKBOX,cblab,NULL);
	cline=ggiWidgetCreateWidget(GWT_CONTAINER_LINE,1,1,but1,but2,NULL);
	cline->gravity=GWT_GRAV_STRETCH;
	txt   =ggiWidgetCreateWidget(GWT_TEXT,testtext,20,80);
	odo   =ggiWidgetCreateWidget(GWT_ODOMETER,50,30.0,330.0,0.0,100.0,9,1);
	odo->statevar=&odoread1;
	dial  =ggiWidgetCreateWidget(GWT_DIAL,"Kekse",50,30.0,330.0,0.0,100.0,9,1,1.0,10.0,5,1);
	dial->statevar=&odoread2;
	cline2=ggiWidgetCreateWidget(GWT_CONTAINER_LINE,5,5,odo,dial,NULL);
	cstack=ggiWidgetCreateWidget(GWT_CONTAINER_STACK,3,3,lab,cline,txt,cline2,NULL);
	bmap  =ggiWidgetCreateWidget(GWT_BITMAP,bitmap);

	but1->callback=callback;
	but2->callback=callback;

	ggiWidgetAttach(cstack,vis,20,50,216,256);

	for(x=0;x<16;x++) {
		ggiSetGCForeground(vis,0);
		ggiDrawBox(vis,0,0,256,256);
		cstack->gravity=x;
		cstack->childchanged(cstack,NULL);
		cstack->redraw(cstack,1);

		usleep(WAIT);
	}
	for(x=0;x<16;x++) {
		ggiSetGCForeground(vis,0);
//		ggiDrawBox(vis,0,0,256,256);
		lab->gravity=x;
		lab->redraw(lab,1);
		usleep(WAIT);
	}
	if (lab1!=but1->unlinkchild(but1,0)) {
		fprintf(stderr,"Huh - couldn't unlink lab1.\n");
	}
	lab1->destroy(lab1);
	for(x=0;x<16;x++) {
		ggiSetGCForeground(vis,0);
		ggiDrawBox(vis,0,0,256,256);
		but1->gravity=x;
		but1->childchanged(but1,NULL);
		cstack->redraw(cstack,1);

		usleep(WAIT);
	}
	lab1=ggiWidgetCreateWidget(GWT_LABEL,"Twoline\nLabel");
	if (but1->linkchild(but1,0,lab1)) {
		fprintf(stderr,"Huh - couldn't link new child\n");
	}
	for(x=0;x<16;x++) {
		ggiSetGCForeground(vis,0);
		ggiDrawBox(vis,0,0,256,256);
		but1->gravity=x;
		but1->childchanged(but1,NULL);
		cstack->redraw(cstack,1);

		usleep(WAIT);
	}

	while(!quit) {
		ggi_event ev;
		
		ggiEventRead(vis,&ev,emAll);	
		ggiWidgetProcessEvent(vis,&ev);
	}
	fprintf(stderr,"Odometers now read %f and %f.\n",odoread1,odoread2);

	ggiWidgetDetach(cstack,vis);
	cstack->destroy(cstack);

	cstack=ggiWidgetMakeMessagebox("Test der Messagebox-\nFunktionen ?",0x111,bmap,&quit);
	ggiWidgetAttach(cstack,vis,20,50,216,256);
	cstack->redraw(cstack,1);

	quit=0;
	while(!quit) {
		ggi_event ev;
		
		ggiEventRead(vis,&ev,emAll);	
		ggiWidgetProcessEvent(vis,&ev);
	}
	fprintf(stderr,"Ended with %x.\n",quit);

	ggiWidgetDetach(cstack,vis);
	cstack->destroy(cstack);

	ggiClose(vis);
	ggiExit();
	return 0;
}
